// ACTION HANDLING

// Object: Action

function Action(n,dn,t) {
  this.name = n;
  this.divname = dn;
  this.text = t;
  this.state = 0;
  this.enter=actionEnter;
  this.leave=actionLeave;
  this.click=actionClick;
  this.cancel=actionCancel;
  this.submit=actionSubmit;
  this.remote=actionRemote;
  this.finish=actionFinish;
  this.replaces=null;
  this.bookingtext="";
  this.clashed=null;
  this.booking=null;
  this.bookingauth=[];
}

function actionEnter() {
  if (this.state) SET_IMG_SRC('actionImg',booko);
}

function actionLeave() {
  if (this.state) SET_IMG_SRC('actionImg',booke);
  else SET_IMG_SRC('actionImg',bookd);
}

function actionClick() {
// make sub-frame cover whole window now perhaps (not title)
// so as to make it impossible to use grid - or could disable grid click?
// as well as scrollbars ....
// freeze other changes
  if (this.state||this.replaces) {
    remote.call();
    SET_LYR_VISIBLE('checkDiv');
  } else java.awt.Toolkit.getDefaultToolkit().beep();
}

function actionCancel() {
  SET_LYR_HIDDEN('checkDiv');
  if (this.replaces) this.replaces = null;
}

function actionRemote() {
  f=document.submit;
  if (remote.answer!="") {
    f.username.value = remote.answer;
    f.username.disabled = true;
    f.password.value = "REMOTE_USER";
    f.password.disabled = true;
  } else if (f.password.value=="REMOTE_USER") {
    f.username.value = "";
    f.username.disabled = false;
    f.password.value = "";
    f.password.disabled = false;
  }
}

function actionSubmit() {
var u, p, r, y, ys, ds, i, j, c, mds, f, s, e, h, qs, dhs;
  f=document.submit;
  u=f.username.value;
  p=f.password.value;
  r=f.purpose.value;
  r=r.replace(/[\x22\x25\x26\x28\x29\x3F]/g,'');
  this.bookingtext='';
  this.clashed=0;
  this.booking = new GridBook(u,0,1,r,u,1,r,slate.hour.pattern[panel.hour.quarter.patternpart]);
  if (this.replaces) {
    this.booking.replaces = this.replaces.reference;
    this.clashed=this.booking.insert(this.replaces.dateSlot,[],[]);
  } else {
    with (slate) {
      y=Math.round(guide.getYfactor()*(match.length-outerheight));
      for (r=0; r<innerheight; r++,y++) {
        if (hour.selectc[r]) {
          ys=match[y];
          ds=data[ys][10];
          hour.selectl[r].sort(function(a,b){return((a==null?100:a)-(b==null?100:b));});
          room.selectl[r].sort(function(a,b){return((a==null?100:a)-(b==null?100:b));});
          if (!this.clashed)
            this.clashed=this.booking.insert(ds,hour.selectl[r],room.selectl[r]);
// build mail message body for booking
          mds = ds.toString();
          this.bookingtext+='  '+mds.substring(6,8)+'/'+mds.substring(4,6)+'/'+mds.substring(0,4);
          for (i=0; i<room.selectl[r].length&&room.selectl[r][i]>=0; i++) {
            if (!i) this.bookingtext+=' use '+room.data[room.selectl[r][i]][1];
            else this.bookingtext+=','+room.data[room.selectl[r][i]][1];
            for (j=0; j<this.bookingauth.length &&
              this.bookingauth[j]!=room.data[room.selectl[r][i]][2]; j++);
            if (j==this.bookingauth.length &&
              room.data[room.selectl[r][i]][2]!='')
              this.bookingauth[j] = room.data[room.selectl[r][i]][2];
          }
          dhs=[];
          for (h=0,i=0,s=hour.selectl[r][i],e=s; s>=0; ) {
            if (++i<hour.selectl[r].length) qs = hour.selectl[r][i];
            else qs = -1;
            for(e=(e+1)%96; !(Math.pow(2,e&3)&slate.hour.pattern[panel.hour.quarter.patternpart]); e++);
            if (qs!=e) {
              dhs[h++] = hour.data[s][2] + "-" + hour.data[e][2];
              s = qs;
              e = s;
            }
          }
          this.bookingtext+=' at '+dhs.toString();
          this.bookingtext+='%0A';
// all rather messy having to clear selections here:
          hour.selectc[r]=0;
          for(i=0; i<hour.select[r].length; i++) hour.select[r][i]=0;
          for(c=0; c<hour.cell[r].length; c++) hour.cell[r][c].select=0;
          hour.selectl[r]=hour.selectl[r].slice(9);
          room.selectc[r]=0;
          for(i=0; i<room.select[r].length; i++) room.select[r][i]=0;
          for(c=0; c<room.cell[r].length; c++) room.cell[r][c].select=0;
          room.selectl[r]=room.selectl[r].slice(3);
// end of messy stuff
        }
      }
    }
  }
  insert.call(u,p,slate.fetchref,this.booking.cgidata);
}

function actionFinish() {
var f, mfrom, t, mto, mcc, msubject, h, n;
  this.booking.reference=insert.answer[0]-0;
  this.clashed=insert.answer[1]-0;
  f=document.submit;
  mfrom=f.username.value;
  t=f.recipient.value;
  if (t&&!this.clashed) mto=t;
  else mto=f.username.value;
  mcc=f.username.value;
  if (this.bookingauth.length>0) mcc+=','+this.bookingauth.join(',');
  h="%23%LOCAL_TAG%";
  n="%0A";
  if (this.clashed)
    msubject='[SHEZHU] DOUBLE BOOKING FAILURE OF '+h.toUpperCase()+this.booking.reference;
  else msubject='[SHEZHU] CONFIRMATION OF '+h.toUpperCase()+this.booking.reference;
  this.bookingtext='  Opened By : '+this.booking.openedBy
          +n+'  Reference : %LOCAL_TAG%'+this.booking.reference
          +n+'  Purpose   : '+this.booking.purpose
          +n+'  Closed By : '+this.booking.closedBy
          +n+n+this.bookingtext;
  SET_LYR_HIDDEN('checkDiv');
  if (this.replaces) {
    this.replaces=null;
    f.purpose.value = '';
  } else {
    SET_IMG_SRC('actionImg',bookd);
    this.state=0;
  }
// booking was not made for some reason if reference not updated so
// we do not need to refresh and should not send a message
  if (this.booking.reference) {
    refresh(1);
    finish.call(mfrom,mto,mcc,msubject,this.bookingtext);
  }
}
