USE mysql;
DROP DATABASE IF EXISTS shezhu;
CREATE DATABASE shezhu;
USE shezhu;
DROP TABLE IF EXISTS bookData;
CREATE TABLE bookData (
   OpenedAt timestamp(14),
   OpenedBy char(40) NOT NULL,
   Reference int(11) NOT NULL auto_increment,
   Replaces int(11) DEFAULT '-1' NOT NULL,
   Request tinyint(4) DEFAULT '0' NOT NULL,
   Reserve tinyint(4) DEFAULT '0' NOT NULL,
   Purpose char(60) NOT NULL,
   ClosedAt timestamp(14),
   ClosedBy char(40),
   ClosedAs tinyint(4),
   Reason char(60),
   DateSlot int(11) DEFAULT '0' NOT NULL,
   HourScope tinyint(4) DEFAULT '0' NOT NULL,
   HourSlot1 tinyint(4) DEFAULT '-1' NOT NULL,
   HourSlot2 tinyint(4) DEFAULT '-1' NOT NULL,
   HourSlot3 tinyint(4) DEFAULT '-1' NOT NULL,
   HourSlot4 tinyint(4) DEFAULT '-1' NOT NULL,
   HourSlot5 tinyint(4) DEFAULT '-1' NOT NULL,
   HourSlot6 tinyint(4) DEFAULT '-1' NOT NULL,
   HourSlot7 tinyint(4) DEFAULT '-1' NOT NULL,
   HourSlot8 tinyint(4) DEFAULT '-1' NOT NULL,
   HourSlot9 tinyint(4) DEFAULT '-1' NOT NULL,
   RoomSlot1 tinyint(4) DEFAULT '-1' NOT NULL,
   RoomSlot2 tinyint(4) DEFAULT '-1' NOT NULL,
   RoomSlot3 tinyint(4) DEFAULT '-1' NOT NULL,
   PRIMARY KEY (Reference, DateSlot),
   UNIQUE Reference (Reference, DateSlot)
);
