// FEATURE HANDLING

function featureEnter(c,d) {
  if (c < 0) SET_LYR_BGCOLOR(this.divname,'orange');
  else if (d < 0) SET_LYR_BGCOLOR(this.cell[c].divname,'orange');
  else SET_LYR_BGCOLOR(this[this.division[d]].cell[c].divname,'orange');
}

function featureLeave(c,d) {
  if (c < 0) {
    if (this.state < 0) SET_LYR_BGCOLOR(this.divname,'white');
    else SET_LYR_BGCOLOR(this.divname,'silver');
  }
  else if (d < 0) {
    if (this.cell[c].state < 0)
      SET_LYR_BGCOLOR(this.cell[c].divname,'white');
    else if (this.cell[c].state > 0)
      SET_LYR_BGCOLOR(this.cell[c].divname,'silver');
    else SET_LYR_BGCOLOR(this.cell[c].divname,'lime');
  }
  else if (this[this.division[d]].cell[c].state < 0)
    SET_LYR_BGCOLOR(this[this.division[d]].cell[c].divname,'white');
  else if (this[this.division[d]].cell[c].state > 0)
    SET_LYR_BGCOLOR(this[this.division[d]].cell[c].divname,'silver');
  else SET_LYR_BGCOLOR(this[this.division[d]].cell[c].divname,'lime');
}

function featureClick(c,d) {
var dc, s, p, i;
  if (c < 0) {
    if (this.state < 0) {
      this.state = 1;
      SET_LYR_BGCOLOR(this.divname,'silver');
      for (d=0;d<this.division.length;d++) {
        for(c=0;c<this[this.division[d]].cell.length;c++) {
          this[this.division[d]].cell[c].state = -1;
          SET_LYR_BGCOLOR(this[this.division[d]].cell[c].divname,'white');
        }
      }
      for (c=0;c<this.cell.length;c++) {
        if (this.cell[c].state > 0) {
          if (this.now == c) {
            this.cell[c].state = 0;
            SET_LYR_BGCOLOR(this.cell[c].divname,'lime');
          }
          else {
            this.cell[c].state = -1;
            SET_LYR_BGCOLOR(this.cell[c].divname,'white');
          }
        }
      }
    }
  }
  else if (d < 0) {
    if (this.cell[c].state <= 0) {
      this.cell[c].state = 1;
      SET_LYR_BGCOLOR(this.cell[c].divname,'silver');
      if (this.state > 0) {
        this.state = -1;
        SET_LYR_BGCOLOR(this.divname,'white');
      }
      for (d=0;d<this.division.length;d++) {
        for(dc=0;dc<this[this.division[d]].cell.length;dc++) {
          if (this[this.division[d]].cell[dc].state > 0
            && c >= this[this.division[d]].cell[dc].gte
            && c <= this[this.division[d]].cell[dc].lte) {
            this[this.division[d]].cell[dc].state = -1;
            SET_LYR_BGCOLOR(this[this.division[d]].cell[dc].divname,'white');
          }
        }
      }
    }
    else if (this.cell[c].state > 0) {
      if (this.now == c) {
        this.cell[c].state = 0;
        SET_LYR_BGCOLOR(this.cell[c].divname,'lime');
      }
      else {
        this.cell[c].state = -1;
        SET_LYR_BGCOLOR(this.cell[c].divname,'white');
      }
      if (this.state < 0) {
        for(s=this.cell.length-1;s>=0&&this.cell[s].state<=0;s--);
        if (s < 0) {
// won't work for >1 division
          for (d=0;d<this.division.length;d++) {
            for(s=this[this.division[d]].cell.length-1;s>=0&&this[this.division[d]].cell[s].state<=0;s--);
          }
          if (s < 0) {
            this.state = 1;
            SET_LYR_BGCOLOR(this.divname,'silver');
          }
        }
      }
    }
  }
  else if (this[this.division[d]].cell[c].state <= 0) {
    this[this.division[d]].cell[c].state = 1;
    SET_LYR_BGCOLOR(this[this.division[d]].cell[c].divname,'silver');
    if (this.state > 0) {
      this.state = -1;
      SET_LYR_BGCOLOR(this.divname,'white');
    }
    else {
      for (dc=this[this.division[d]].cell[c].gte;dc<=this[this.division[d]].cell[c].lte;dc++) {
        if (this.cell[dc].state > 0) {
          if (this.now == dc) {
            this.cell[dc].state = 0;
            SET_LYR_BGCOLOR(this.cell[dc].divname,'lime');
          }
          else {
            this.cell[dc].state = -1;
            SET_LYR_BGCOLOR(this.cell[dc].divname,'white');
          }
        }
      }
    }
  }
  else if (this[this.division[d]].cell[c].state > 0) {
    this[this.division[d]].cell[c].state = -1;
    SET_LYR_BGCOLOR(this[this.division[d]].cell[c].divname,'white');
    if (this.state < 0) {
      for(s=this[this.division[d]].cell.length-1;s>=0&&this[this.division[d]].cell[s].state<=0;s--);
      if (s < 0) {
        for(s=this.cell.length-1;s>=0&&this.cell[s].state<=0;s--);
        if (s < 0) {
          this.state = 1;
          SET_LYR_BGCOLOR(this.divname,'silver');
        }
      }
    }
  }
  if (this.state < 0) {
    s=0;
    for (d=0; d<this.division.length; d++) {
      for (c=0; c<this[this.division[d]].cell.length; c++) {
        if (this[this.division[d]].cell[c].state > 0) {
          p = Math.pow(2,this[this.division[d]].cell[c].gte);
          for (i=this[this.division[d]].cell[c].gte; i<=this[this.division[d]].cell[c].lte; i++, p*=2) {
            s += p;
          }
        }
      }
    }
    for (c=0,p=1; c<this.cell.length; c++, p*=2) {
      s += p * Math.max(0,this.cell[c].state);
    }
  }
  else s = Math.pow(2,this.patternsize) - 1;
  if (this.pane!=null) {
    if (this.pane<0) this.grid.adjust(s,this.patternpart);
    else this.grid[this.grid.pane[this.pane]].adjust(s,this.patternpart);
  }
  else this.grid.slotadjust(s);
}

function featureLaunch() {
var p, f;
  if (this.pane==null) this.grid.slotpattern = this.pattern;
  else {
    if (this.pane<0) this.grid.pattern[this.patternpart] = this.pattern;
    else {
      p=this.grid.pane[this.pane];
      this.grid[p].pattern[this.patternpart] = this.pattern;
      this.grid[p].patternsize[this.patternpart] = this.patternsize;
    }
  }
  for (f=0; f<this.feature.length; f++) {
    this[this.feature[f]].launch();
  }
}

function featureChange(n) {
  if (this.internal) return;
  if (this.now >= 0 && this.cell[this.now].state == 0) {
    this.cell[this.now].state = -1;
    SET_LYR_BGCOLOR(this.cell[this.now].divname,'white');
  }
  if (n >= 0 && n < this.cell.length && this.cell[n].state < 0) {
    this.cell[n].state = 0;
    SET_LYR_BGCOLOR(this.cell[n].divname,'lime');
  }
  if (n < this.cell.length) this.now = n;
}

function featureCreate() {
var div, d, c, f;
  if (this.internal) return('');
  if (this.inactive) div = '<DIV ID="'+this.divname+'">'+this.text+'</DIV>';
  else div = '<DIV ID="'+this.divname+'"><A HREF="javascript:'+this.name+'.click(-1,-1)" onMouseOver="'+this.name+'.enter(-1,-1)" onMouseOut="'+this.name+'.leave(-1,-1)">'+this.text+'</A></DIV>';
  if (this.hide == 1) div += '<DIV ID="'+this.divname+'Hide'+'"></DIV>';
  for (d=0; d < this.division.length; d++) {
    for (c=0; c < this[this.division[d]].cell.length; c++) {
      div += '<DIV ID="'+this[this.division[d]].cell[c].divname+'"><A HREF="javascript:'+this.name+'.click('+c+','+d+')" onMouseOver="'+this.name+'.enter('+c+','+d+')" onMouseOut="'+this.name+'.leave('+c+','+d+')">'+this[this.division[d]].cell[c].text+'</A></DIV>\n';
    }
  }
  for (c=0; c < this.cell.length; c++) {
    div += '<DIV ID="'+this.cell[c].divname+'"><A HREF="javascript:'+this.name+'.click('+c+',-1)" onMouseOver="'+this.name+'.enter('+c+',-1)" onMouseOut="'+this.name+'.leave('+c+',-1)">'+this.cell[c].text+'</A></DIV>\n';
  }
  for (f=0; f < this.feature.length; f++) {
    div += this[this.feature[f]].create();
  }
  return(div);
}

function featureLayout(x,y) {
var xo, yo, str, wi, wf, i, l, c, f, s, h, w, o, d, by, dx, dw, color, r, rw, owf, vis;
  if (this.internal) return('');
  if (this.hide == 1) vis = 'hidden';
  s = this.span;
  h = this.height;
  w = this.width;
  o = this.orientation;
  if (this.state < 0) color = 'white';
  else color = 'silver';
  this.featurewidth = w * s + s - 1;
  str = "";
  wi = parseInt(w);
  owf = w - wi;
  by = y;
  y = y + h + this.gap;
  this.featureheight = h;

  for (d=0,dx=x,dw=0; d < this.division.length; d++) {
    for (i=0; i < this[this.division[d]].cell.length; i++) {
      dw = (this[this.division[d]].cell[i].lte
        - this[this.division[d]].cell[i].gte + 1) * w
        + (this[this.division[d]].cell[i].lte
        - this[this.division[d]].cell[i].gte);
      if (this[this.division[d]].cell[i].state < 0) color = 'white';
      else color = 'silver';
      str += css(this[this.division[d]].cell[i].divname,dx,y,dw,h,color,vis,0,'padding:1px');
      dx += dw + 1;
    }
    y = y + h + this.gap;
    this.featureheight += this.gap + h;
  }

  for (i=0,l=0,c=0,r=0; i < this.cell.length; i++) {
    if (l == 0) {
      r += 1;
      xo = x;
      wf = owf;
      w = wi;
    }
    else {
      xo += w + 1;
      if (w!=wi) {
        w = wi;
      }
      if (wf >= 1) {
        w += 1;
        wf -= 1;
      }
    }
    yo = y+(c*h)+c;
    if (this.cell[i].state < 0) color = 'white';
    else color = 'silver';
    if (i==(this.cell.length-1)&&((l+1)%s)!=0) w = this.featurewidth - (xo - x);
    l = (l + 1) % s;
    c = parseInt(1+((i+1)/s))-1;
    str += css(this.cell[i].divname,xo,yo,w,h,color,vis,0,'padding:1px');
    wf += owf;
  }
  this.featureheight += this.gap + r * h + r - 1;
  if (o <= 0) xo = x;
  else xo = x + this.featurewidth + 1;
  y = by + h + this.gap;
  if (o <= 0) yo = by + this.featureheight + this.gap;
  else yo = y;
  for (f=0,r=0,rw=0; f<this.feature.length; f++) {
    str += this[this.feature[f]].layout(xo,yo);
    if (f+1<this.feature.length && (f+1) % this.subspan == 0) {
      if (o > 0) rw = Math.max(rw,xo+this[this.feature[f]].featurewidth-x);
      r += 1;
      xo = x;
      yo += this[this.feature[f]].featureheight + this.gap;
      this.featureheight += this.gap + this[this.feature[f]].featureheight;
    }
    else if (o > 0 && this[this.feature[f]].featurewidth > 0)
      xo += this[this.feature[f]].featurewidth + this.gap;
    if (o <= 0) this.featureheight += this.gap + this[this.feature[f]].featureheight;
  }
  if (r >= 1) {
    this.featureheight += this.gap + this[this.feature[f-1]].featureheight;
  }
  if (o > 0) this.featurewidth = Math.max(rw,xo-x-this.gap);
  if (this.state < 0) color = 'white';
  else color = 'silver';
  str += css(this.divname,x,by,this.featurewidth,h,color,vis,0,'padding:1px');
  if (this.hide == 1) {
    str += css(this.divname+'Hide',x,by,this.featurewidth,this.featureheight,color,null,1,'padding:1px');
  }
  return(str);
}

function featureAppend(name,divname,text,initial,values,span,width,orient,f,comp,g,gi,hide,idp,i) {
var c;
  this.feature[this.feature.length] = name;
  if (!idp) idp='';
  text = '<IMG SRC="'+idp+'images/'+text+'.gif" BORDER="0">';
  this[name] = new Feature(this.name+'.'+name,divname+'Div',text,span,this.subheight,width,this.subheight,orient,2);
  for (c=0;c<values.length;c++) {
    if (values[c]!=null) this[name].cell[c] = new FeatureCell(name+values[c],divname+values[c]+'Div','<IMG SRC="'+idp+'images/'+values[c]+'.gif" BORDER="0">');
    else this[name].cell[c] = new FeatureCell(name+'NA'+c,divname+'NA'+c+'Div','');
  }
  if (comp) this[name].complement = comp;
  if (f) this[name].patternsize = f;
  else this[name].patternsize = this[name].cell.length;
  this[name].patternsize += this[name].complement;
  if (initial < 0) {
    this[name].state = 1;
    this[name].pattern = Math.pow(2,this[name].patternsize) - 1;
  }
  else {
    this[name].cell[initial].state = 1;
    this[name].pattern = Math.pow(2,initial);
  }
  this[name].gap = this.subgap;
  this[name].subgap = this[name].gap;
  this[name].pane = g;
  this[name].patternpart = gi;
  this[name].hide = hide;
  this[name].internal = i;
}

function featureDivide(name,initial,values) {
var c, p, i;
  this.division[this.division.length] = name;
  this[name] = new FeatureDivision(initial);
  for (c=0;c<values.length;c++) {
    this[name].cell[c] = new FeatureDivisionCell(name+values[c][0],name+values[c][1]+'Div','<IMG SRC="images/'+values[c][0]+'.gif" BORDER="0">',values[c][2],values[c][3]);
  }
  if (initial >= 0) {
    this.state = -1;
    this[name].cell[initial].state = 1;
    this.pattern = 0;
    p = Math.pow(2,this[name].cell[initial].gte);
    for (i=this[name].cell[initial].gte; i<=this[name].cell[initial].lte; i++, p*=2) {
      this.pattern += p;
    }
  }
}

// Object: Feature, component of panel

function Feature(n,dn,t,s,h,w,sh,o,ss,a) {
  this.name = n; // name of feature (for reference)
  this.divname = dn; // div name of feature
  this.text = t; // title of feature on name panel
  this.now = -1; // current feature date value (cell index)
  this.state = -1;
  this.span = s;
  this.subspan = ss;
  this.height = h;
  this.width = w;
  this.subheight = sh;
  this.gap = 2;
  this.subgap = 1;
  this.orientation = o;
  this.inactive = a;
  this.featurewidth = -1;
  this.featureheight = -1;
  this.enter = featureEnter;
  this.leave = featureLeave;
  this.click = featureClick;
  this.change = featureChange;
  this.append = featureAppend;
  this.divide = featureDivide;
  this.create = featureCreate; // recurses through sub-features
  this.layout = featureLayout; // recurses through sub-features
  this.launch = featureLaunch; // startup stuff, recurses through sub-features
  this.cell = []; // array of cell objects
  this.division = []; // array of division names
  this.feature = []; // array of sub-feature names
  this.update = new Function(); // function to call on state change
  this.pattern = null; // match all pattern
  this.complement = 0; // match all pattern complement bit enabled
  this.pane = null; // index of associated grid pane (-1 for v-axis)
                   // 0..N for h-axis, c-axis???
  this.patternpart = null; // part of the grid pattern feature affects
  this.patternsize = null; // length in bits of pattern (default is N cells)
  this.hide = null; // if set hide this feature behind a null layer
  this.internal = null; // if set do not display feature (but make pattern)
}

// Object: component of feature

function FeatureCell(n,dn,t) {
  this.name = n;
  this.divname = dn;
  this.text = t;
  this.state = -1;
}

// Object: division of feature

function FeatureDivision(i) {
  this.initial = i;
  this.cell = [];
}

// Object: cell of division

function FeatureDivisionCell(n,dn,t,g,l) {
  this.name = n;
  this.divname = dn;
  this.text = t;
  this.state = -1;
  this.gte = g;
  this.lte = l;
}
