// GRID METHODS

function gridHeader() {
var r;
  for (r=0; r<this.outerheight; r++) {
    this.lead[r] = new GridLeadCell(this.name+r,this.divname+r+'Div',this.divname+r+'Img');
  }
  this.height = this.outerheight * this.cellheight + this.outerheight - 1;
  this.unitheight = this.height / this.outerheight;
  this.handleheight = this.unitheight * this.outerheight;
// add a grid object reference to all features
  Feature.prototype.grid=this;
}

function gridAppend(name,divname,text,nc,data,idp) {
var c, r, i, j;
  this.pane[this.pane.length] = name;
  this[name] = new GridPane(this.name+'.'+name,divname+'Div',text,nc,data);
  for (c=0; c<this[name].outerwidth; c++) {
    this[name].lead[c] = new GridLeadCell(name+c,divname+c+'Div',divname+c+'Img');
  }
  for (r=0; r<this.outerheight; r++) {
    this[name].cell[r] = new Array(this[name].outerwidth);
    for (c=0; c<this[name].outerwidth; c++) {
      this[name].cell[r][c] = new GridCell(name+r+'x'+c,divname+r+'x'+c+'Div',divname+r+'x'+c+'Img');
    }
  }
  if (idp) this[name].imgdirpfx = idp;
  else this[name].imgdirpfx = '';
  this[name].cellwidth = this.cellwidth;
  this[name].cellheight = this.cellheight;
  this[name].leadheight = this.leadheight;
  this[name].width = nc * this.cellwidth + nc - 1;
  this[name].unitwidth = this[name].width / nc;
  this[name].handlewidth = this[name].unitwidth * nc;
  this[name].grid = this;
// THIS IS FOR NEW STUFF BUT IS PROBABLY WRONG
// YES: select, selectc and selectl are all displayed rows only, ie. only
// 12 elements - not hundreds!
  for (i=0; i<this.data.length; i++) {
    this[name].count[i] = [];
    this[name].select[i] = [];
    this[name].selectl[i] = [];
    this[name].selectc[i] = 0;
// nc is wrong (needs to be total slots not displayed slots)
    for (j=0; j<96; j++) {
      this[name].count[i][j] = [];
//    this[name].value[i] = [];
    }
  }
}

function gridLayout(x,y) {
var str="", r, xo, yo, yg, p;
  yo = y + this.leadheight + 1 + this.leadheight + 2;
  str += css(this.divname+'ULDiv',x,y,this.leadwidth,yo-y-2,'yellow',null,0,'padding:1px');
  yg = yo;
  for (r=0; r<this.outerheight; r++) {
    str += css(this.lead[r].divname,x,yo,this.leadwidth,this.cellheight,'white',null,0,'padding:1px');
    yo += this.cellheight + 1;
  }
  xo = x + this.leadwidth + 2;
  for (p=0; p<this.pane.length; p++) {
    str += this[this.pane[p]].layout(xo,y);
    xo += this[this.pane[p]].width + 1;
  }
  str += css(this.divname+'URDiv',xo+1,y,16,yg-y-2,'yellow',null,0,'padding:1px');
  str += css(this.divname+'LLDiv',x,yo+1,this.leadwidth,16,'yellow',null,0,'padding:1px');
  str += css(this.divname+'LRDiv',xo+1,yo+1,16,16,'yellow',null,0,'padding:1px');
  this.guide = new ScrollBar(xo+1,yg,16,this.height,16,this.handleheight,this.unitheight,this);
  this.guide.bgColor = 'gray';
  this.guide.boxColor = 'silver';
  this.guide.onScroll = this.scroll;
  this.guide.build();
  str += this.guide.css;
  return(str);
}

function gridPaneLayout(x,y) {
var str, xo, yo, c, r;
  str = css(this.divname,x,y,this.width,this.leadheight,'yellow',null,0,'padding:1px');
  xo = x;
  for (c=0; c<this.outerwidth; c++) {
    yo = y + this.leadheight + 1;
    str += css(this.lead[c].divname,xo,yo,this.cellwidth,this.leadheight,'white',null,0,'padding:1px');
    yo += this.leadheight + 2;
    for (r=0; r<this.cell.length; r++) {
      str += css(this.cell[r][c].divname,xo,yo,this.cellwidth,this.cellheight,'white',null,0,'padding:1px');
//      if (c==0) str += css('RS'+r+this.divname,xo,yo-1,this.width,1,'black',null,0,'padding:1px');
      yo += this.cellheight + 1;
    }
    xo += this.cellwidth + 1;
  }
  this.guide = new ScrollBar(x,yo+1,this.width,16,this.handlewidth,16,this.unitwidth,this);
  this.guide.bgColor = 'gray';
  this.guide.boxColor = 'silver';
  this.guide.onScroll = this.scroll;
  this.guide.build();
  str += this.guide.css;
  return(str);
}

function gridCreate() {
var div, r, p;
  div = '<DIV ID="'+this.divname+'ULDiv"><IMG SRC="images/'+this.text+'.gif" BORDER="0"></DIV>';
  for (r=0; r<this.lead.length; r++) {
// note height/width need to be derived here not hard coded
    div += '<DIV ID="'+this.lead[r].divname+'"><IMG SRC="" HEIGHT=24 WIDTH=147 NAME="'+this.lead[r].imgname+'" BORDER="0"></DIV>\n';
  }
  for (p=0; p<this.pane.length; p++) {
    div += this[this.pane[p]].create();
  }
  div += '<DIV ID="'+this.divname+'URDiv"></DIV>\n';
  div += '<DIV ID="'+this.divname+'LLDiv"></DIV>\n';
  div += '<DIV ID="'+this.divname+'LRDiv"></DIV>\n';
  div += this.guide.div;
  return(div);
}

function gridPaneCreate() {
var div, c, r;
  div = '<DIV ID="'+this.divname+'"><IMG SRC="images/'+this.text+'.gif" BORDER="0"></DIV>';
  for (c=0; c<this.lead.length; c++) {
// note height/width need to be derived here not hard coded
    div += '<DIV ID="'+this.lead[c].divname+'"><IMG SRC="" HEIGHT=14 WIDTH=48 NAME="'+this.lead[c].imgname+'" BORDER="0"></DIV>\n';
    for (r=0; r<this.cell.length; r++) {
      div += '<DIV ID="'+this.cell[r][c].divname+'"><A HREF="javascript:'+this.name+'.click('+r+','+c+')" onMouseOver="'+this.name+'.enter('+r+','+c+')" onMouseOut="'+this.name+'.leave('+r+','+c+')"><IMG SRC="'+this.cell[r][c].image+'" HEIGHT=24 WIDTH=48 NAME="'+this.cell[r][c].imgname+'" BORDER="0"></A></DIV>\n';
//      if (c==0) div += '<DIV ID="RS'+r+this.divname+'"></DIV>\n';
    }
  }
  div += this.guide.div;
  return(div);
}

if (is.ie) {
  var gridValueRow, gridValueColumn, gridValuePane;
}
function gridValue(r,c,p) {
var s, y, ys, x, xs, b, d, h, l, dhs, drs, f, e, qs, rs;
var fs, r, bi, rows=[], i, j, k;
  if (is.ie) {
    r=gridValueRow;
    c=gridValueColumn;
    p=gridValuePane;
  }
  s='<TABLE WIDTH="778" CELLSPACING=1 CELLPADDING=1 BORDER=1 BGCOLOR="silver">';
  y=Math.round(slate.guide.getYfactor()*(slate.match.length-slate.outerheight));
  ys=slate.match[y+r];
  x=Math.round(p.guide.getXfactor()*(p.match.length-p.outerwidth));
  xs=p.match[x+c];
// only displays for matching start slots (doesn't do qtr. res. mapping)
// no handling for number of displayed bookings exceeding panel size
  for (b=0,bi=0; b<slate.fetch[ys].length; b++) {
    d=0;
    if(p.name=="slate.hour") {
      for (h=0; slate.fetch[ys][b].hourSlot[h]>=0&&!d; h++) {
        qs = slate.fetch[ys][b].hourSlot[h];
        if (qs==xs) d=1;
        else {
          for(rs=(xs+1)%96; !(Math.pow(2,rs&3)&slate.hour.pattern[panel.hour.quarter.patternpart])&&!d; rs++) {
            if (qs==rs) d=1;
          }
          for(qs=(qs+1)%96; !(Math.pow(2,qs&3)&slate.fetch[ys][b].hourScope)&&!d; qs++) {
            if (qs==xs) d=1;
          }
        }
      }
      if (d) {
        d=0;
        for (l=0; slate.fetch[ys][b].roomSlot[l]>=0&&!d; l++) {
          if (slate.room.data[slate.fetch[ys][b].roomSlot[l]][0]&slate.room.pattern[0]) d=1;
        }
      }
    }
    else {
      for (l=0; slate.fetch[ys][b].roomSlot[l]>=0&&!d; l++) {
        if (slate.fetch[ys][b].roomSlot[l]==xs) d=1;
      }
      if (d) {
        d=0;
        for (l=0; slate.fetch[ys][b].hourSlot[l]>=0&&!d; l++) {
          if (slate.hour.data[slate.fetch[ys][b].hourSlot[l]][0]&slate.hour.pattern[0]) d=1;
        }
      }
    }
    if (d) {
      dhs=[];
      for (h=0,l=0,fs=slate.fetch[ys][b].hourSlot[l],f=fs,e=f; f>=0; ) {
        if (++l<9) qs = slate.fetch[ys][b].hourSlot[l];
        else qs = -1;
        for(e=(e+1)%96; !(Math.pow(2,e&3)&slate.fetch[ys][b].hourScope); e++);
        if (qs!=e) {
          dhs[h++] = slate.hour.data[f][2] + "-" + slate.hour.data[e][2];
          f = qs;
          e = f;
        }
      }
      drs=[];
      for (l=0; slate.fetch[ys][b].roomSlot[l]>=0; l++) {
        drs[l]=slate.room.data[slate.fetch[ys][b].roomSlot[l]][1];
      }
      r='<TR><TD WIDTH="10%"><DIV CLASS="dtext">'+dhs.toString()+'</DIV><TD WIDTH="10%"><DIV CLASS="dtext">'+drs.toString()+'</DIV><TD WIDTH="10%"><DIV CLASS="dtext">'+slate.fetch[ys][b].openedBy.toUpperCase()+'</DIV><TD WIDTH="*"><DIV CLASS="dtext">'+slate.fetch[ys][b].purpose+'</DIV>';
      if (p.grid.locked) r+='<TD WIDTH="54"><DIV ID="dbutton"><A HREF="javascript:slate.remove('+ys+','+b+')"><IMG SRC="images/DELETE.gif" BORDER="0"></A></DIV>';
      else r+='<TD WIDTH="54">';
      rows[bi++]=[fs,r];
    }
  }
  for (i=rows.length; i>0; i--) {
    for (j=0,k=0; j<rows.length; j++) {
      if (rows[j][0]<rows[k][0]) k=j;
    }
    s+=rows[k][1];
    if (rows.splice) rows.splice(k,1);
    else {
      var tmp = rows.slice(k+1);
      rows.length=k;
      rows=rows.concat(tmp);
    }
  }
  s+='</TABLE>';
  if (is.ie) document.all['detailDiv'].innerHTML = s;
  else document.getElementById('detailDiv').innerHTML = s;
  SET_LYR_VISIBLE('detailDiv');
}

function gridEnter(r,c) {
  SET_IMG_SRC(this.cell[r][c].imgname,edge);
  if (this.cell[r][c].state) {
    if (is.ie) {
      gridValueRow=r;
      gridValueColumn=c;
      gridValuePane=this;
    }
    timeoutid=setTimeout(gridValue,1000,r,c,this);
  }
  else timeoutid=null;
}

function gridLeave(r,c) {
  SET_IMG_SRC(this.cell[r][c].imgname,spacer);
  if (timeoutid!=null) {
    clearTimeout(timeoutid);
    if (!this.grid.locked) SET_LYR_HIDDEN('detailDiv');
  }
}

function gridClick(r,c) {
var x, xs, n, y, ys, s;
  x=Math.round(this.guide.getXfactor()*(this.match.length-this.outerwidth));
  xs=this.match[x+c];
  if (this.cell[r][c].select != 1) {
// can't select if 100% booked already,
// note that 3 is actually 66%..100% so will probably need to store real
// weight rather than displayed weight to do this properly
// no idea what the qtrs resolution does here - how affects weight avg
// but if at least one qtr of the visible hour is booked then that slot
// cannot be booked is the simplest approach
// its not as as simple as this, need to check the real data as the
// weights are misleading and allow a room to be booked which is already
// booked.
//
// We take a simpler approach to fixing this for now - you simply can't
// select a gray (partially booked) slot. Eg. if 1200/L1 is booked and you
// want to book L2 also for 1200 you must click L2 first to clear the 1200
// slot and then you can click that slot and vice versa. This also works
// fine for dual slot/room bookings. It is only restrictive in the sense
// that you must click to clear first, it doesn't otherwise limit booking
// ranges that are allowed (except perhaps higher hour slot resolutions).
    if (this.cell[r][c].state<1) {
      SET_LYR_BGCOLOR(this.cell[r][c].divname,'orange');
      this.cell[r][c].select = 1;
      this.peer.selectc[r]++;
      this.peer.select[r][1+parseInt(xs/32)] |= Math.pow(2,xs%32);
      this.selectl[r][this.selectl[r].length] = xs;
      if (this.grid.locked) {
        this.grid.locked = 0;
        SET_LYR_HIDDEN('detailDiv');
      }
    } else {
      this.grid.locked = 1;
      if (is.ie) {
        gridValueRow=r;
        gridValueColumn=c;
        gridValuePane=this;
      }
      gridValue(r,c,this);
    }
  }
  else {
    if (this.cell[r][c].state==0)
      SET_LYR_BGCOLOR(this.cell[r][c].divname,'white');
    else if (this.cell[r][c].state==1)
      SET_LYR_BGCOLOR(this.cell[r][c].divname,'#AAAAAA');
    else if (this.cell[r][c].state==2)
      SET_LYR_BGCOLOR(this.cell[r][c].divname,'#707070');
    else SET_LYR_BGCOLOR(this.cell[r][c].divname,'black');
    this.cell[r][c].select = 0;
    this.peer.selectc[r]--;
    this.peer.select[r][1+parseInt(xs/32)] &= ~Math.pow(2,xs%32);
    for (n=0; n<this.selectl[r].length&&this.selectl[r][n]!=xs; n++);
    if (this.selectl[r].splice) this.selectl[r].splice(n,1);
    else {
      var tmp = this.selectl[r].slice(n+1);
      this.selectl[r].length=n;
      this.selectl[r]=this.selectl[r].concat(tmp);
    }
  }


  y=Math.round(this.grid.guide.getYfactor()*(this.grid.match.length-this.grid.outerheight));
  ys=this.grid.match[y+r];
  this.peer.value[ys] = [];
// java.lang.System.out.println(ys+"("+this.peer.selectc[r]+":"+this.peer.select[r].toString()+")");
// only needs to be peer pane really, make per-pane update routines that call
// main update routine with pane argument to do this
  this.grid.update(-1);

// enable/disable action button based on selections
  for (s=0,n=0; n<this.grid.innerheight; n++) {
    if (this.selectc[n] && !this.peer.selectc[n]) {
      s=0;
      break;
    }
    else if (!this.selectc[n] && this.peer.selectc[n]) {
      s=0;
      break;
    }
    else if (this.selectc[n] && this.peer.selectc[n]) s=1;
  }
  if ((s&&!book.state)||(!s&&book.state)) {
    book.state=s;
    book.leave();
  }


// when the filters change the selections are wiped
// if no cells selected the pattern needs to be set such that it isn't
// used and the standard filter pattern is used instead, eg. set null

// since row has changed mark for subsequent update (regeneration of
// display values, so clear this.xref.value[r]

// if clicked on hour pane cell, mark row and room pane for update
// if clicked on room pane cell, mark row and hour pane for update
// this should be distinct from normal update, recognised as a cross
// pattern based on selected cell(s) rather than filter (except for
// the slot type). Selection filter needs to be regenerated after
// any change through here

// can just change the respective xpattern - if the filter changes
// it back this would clear all selections anyway - this wouldnt
// work for a scroll event though which would just trigger update
// there is no update trigger under select at the moment, this will
// have to change - the update is to specific panes based on the
// click origination

// note also that the last deselection on a pane should reset the
// xpattern to the default filter pattern prior to update


// we always update here - a click on a cell must always trigger a
// change in displayed data (for at least one row and pane).
// update only needs to change a single row in this instance though
// so this could be handled efficiently with an argument to update?
// it also only displayed cells in a single pane that can be changed
// at most in a single click, although update has a pane argument


// this raises the issue of whether update should be split into
// separate pane updates as well - this was previously discounted

// 'this' is the pane, r is the row and c is the column in the pane affected
// but actually the update is to the cross pane not the source pane

// the click routine should block the selection of 100% usage weight slots?

// here xpane is an object ref (set on creation) to cross pane
// would have to be done as update, ie. A cant ref B until B exists, but
// B cant ref A until A exists
//  this.xpane.update(row)


// cant select 100% cells
// booking button rules - must have selected one or more cells from each pane
// on one or more rows to enable
// the cells may or may not have existing bookings/reservations/requests on
// them - the actual action is based on the content and user
// however - poss. exception - if user clicks on cell with reservation/request
// does not need to select any other cells to confirm?

}

function gridRemove(ys,b) {
  book.replaces=slate.fetch[ys][b];
  f=document;
  f.submit.purpose.value = 'REMOVE: '+book.replaces.purpose;
  book.click();
  slate.locked = 0;
  SET_LYR_HIDDEN('detailDiv');
}

// Reapply criteria

function gridFilter() {
var i, r, p, h, c, xs;
  for (i=this.datastart,r=0; i<this.data.length; i++) {
    for (p=0; (this.data[i][p]&this.pattern[p])!=0&&p<this.pattern.length; p++);
    if (p==this.pattern.length) this.match[r++] = i;
  }
  this.match.length = r;
  this.unitheight = this.height / Math.max(this.match.length,this.outerheight);
  this.handleheight = this.unitheight * this.outerheight;
  this.guide.update(this.unitheight,null,this.handleheight,null,0);
  for (h=Math.min(r,this.outerheight); r<this.innerheight; r++) {
    SET_LYR_HIDDEN(this.lead[r].divname);
    this.lead[r].index = -1;
    for (p=0; p<this.pane.length; p++) {
      for (c=0; c<this[this.pane[p]].innerwidth; c++) {
        SET_LYR_HIDDEN(this[this.pane[p]].cell[r][c].divname);
      }
    }
  }
// now clear all selected cells in all panes
// we could be clever but lets be simple, filter change clears all selections
// this is probably not as efficient as it could be though
  for (r=0; r<this.innerheight; r++) {
    for (p=0; p<this.pane.length; p++) {
      for (c=0; c<this[this.pane[p]].innerwidth; c++) {
// retain line below for compatibility, ought to be deprecated though
        this[this.pane[p]].cell[r][c].index = -1;
        if (this[this.pane[p]].cell[r][c].select==1) {
          SET_LYR_BGCOLOR(this[this.pane[p]].cell[r][c].divname,'white');
          this[this.pane[p]].cell[r][c].select = 0;
          this[this.pane[p]].cell[r][c].state = 0;
        }
      }
      this[this.pane[p]].peer.selectc[r] = 0;
      this[this.pane[p]].peer.select[r] = [];
      this[this.pane[p]].selectl[r] = [];
    }
  }
// with selections on panes cleared action button must be disabled
  book.state = 0;
  book.leave();
  this.innerheight = h;
  this.leader(); // reload headers
}

function gridPaneFilter() {
var i, p, w, r, s, v, j, c, n, xs;
  for (i=0,c=0; i<this.data.length; i++) {
    for (p=0; (this.data[i][p]&this.pattern[p])!=0&&p<this.pattern.length; p++);
    if (p==this.pattern.length) this.match[c++] = i;
  }
  this.match.length = c;
  this.unitwidth = this.width / Math.max(this.match.length,this.outerwidth);
  this.handlewidth = this.unitwidth * this.outerwidth;
  this.guide.update(this.unitwidth,this.handlewidth,null,0,null);
  for (w=Math.min(c,this.outerwidth); c<this.innerwidth; c++) {
    SET_LYR_HIDDEN(this.lead[c].divname);
    this.lead[c].index = -1;
    for (r=0; r<this.grid.innerheight; r++) {
      SET_LYR_HIDDEN(this.cell[r][c].divname);
    }
  }
// now clear all selected cells in this pane
// we could be clever but lets be simple, filter change clears all selections
// this is probably not hugely efficient though
  for (r=0; r<this.grid.innerheight; r++) {
    for (c=0; c<this.innerwidth; c++) {
// retain line below for compatibility, ought to be deprecated though
      this.cell[r][c].index = -1;
      if (this.cell[r][c].select==1) {
        SET_LYR_BGCOLOR(this.cell[r][c].divname,'white');
        this.cell[r][c].select = 0;
        this.cell[r][c].state = 0;
      }
    }
    this.peer.selectc[r] = 0;
    this.peer.select[r] = [];
    this.selectl[r] = [];
  }
// with selections on one pane cleared action button must be disabled
  book.state = 0;
  book.leave();
  this.innerwidth = w;
// recalculate cross pattern
  this.xpattern[0] = this.grid.slotpattern&0x7;
  this.xpattern[1]=1;
  this.xpatternc=1;
  this.xpatterni[0] = this.grid.slotpattern&0x7;
  for (s=1,p=this.pattern.length-1; p>=0; p--) {
    v=this.xpattern[1];
    for (j=1; j<this.xpattern.length; j++) {
      this.xpattern[j]=0;
      this.xpatterni[j]=0;
    }
    c=this.xpatternc;
    this.xpatternc=0;
    r=s;
    s=this.patternsize[p];
    for (n=0; n<s; n++) {
      if (Math.pow(2,n)&this.pattern[p]) {
        this.xpattern[parseInt(1+n/(32/r))] |= v<<(r*(n%(32/r)));
        this.xpatternc+=c;
      }
    }
  }
  this.xpatternr=c;
  for (n=0,i=1; n||(i<this.xpattern.length); i++) {
    if (n&&(i==this.xpattern.length)) {
      s=n;
      r=1;
    } else {
      s=32;
      r=i;
    }
    for (j=0; j<s; j++) {
      if (!n&&(Math.pow(2,j)&this.xpattern[r])) n=4;
      if (n) {
        this.xpatterni[r] |= Math.pow(2,j)&(~(Math.pow(2,j)&this.xpattern[r]));
        n--;
      }
    }
  }
  this.leader(); // reload headers
}

function gridLeader() {
var o, r, i;
  o = Math.round(this.guide.getYfactor() * (this.match.length - this.outerheight));
  for (r=0; r<this.match.length && r<this.innerheight; r++, o++) {
    i = this.match[o];
    if (this.lead[r].index != i) {
      if (this.imgsrc[i]==null) {
        this.imgsrc[i] = new Image();
        this.imgsrc[i].src = 'base-images/'+this.data[i][this.pattern.length]+'.gif';
      }
      SET_IMG_SRC(this.lead[r].imgname,this.imgsrc[i]);
      if (this.lead[r].index<0) {
        SET_LYR_VISIBLE(this.lead[r].divname);
      }
      this.lead[r].index = this.match[o];
    }
  }
}

function gridPaneLeader() {
var o, c, i;
  o = Math.round(this.guide.getXfactor() * (this.match.length - this.outerwidth));
  for (c=0; o<this.match.length && c<this.innerwidth; c++, o++) {
    i = this.match[o];
    if (this.lead[c].index != i) {
      if (this.imgsrc[i]==null) {
        this.imgsrc[i] = new Image();
        this.imgsrc[i].src = this.imgdirpfx+'images/'+this.data[i][this.pattern.length]+'.gif';
      }
      SET_IMG_SRC(this.lead[c].imgname,this.imgsrc[i]);
      if (this.lead[c].index<0) {
        SET_LYR_VISIBLE(this.lead[c].divname);
      }
      this.lead[c].index = this.match[o];
    }
  }
}

function gridUpdate(ip) {
var y, r, ys, b, t, rs, hs, s, q, j, p, pane, pattern, patternc, x, c, xs, v, xp, ns, sxs, ipattern;

// stuff in here to update count list values if changed
// then to update grid value list if changed
// then change to use this rather than data from header data

  y=Math.round(this.guide.getYfactor()*(this.match.length-this.outerheight));
  for (r=0; r<this.innerheight; r++, y++) {
    ys=this.match[y];
// putting this check in breaks ?
// without, repeatedly calls without need and appends same data
    // if room done so must hour and vice versa
    if (!this.room.count[ys]||!this.room.count[ys].length) {
      if (this.fetch[ys]) {
        for (b=0; b<this.fetch[ys].length; b++) {
          t = this.fetch[ys][b].closedAs ? 1 : this.fetch[ys][b].request*4 | this.fetch[ys][b].reserve*2;
          if (!this.fetch[ys][b].roomPattern) {
            this.fetch[ys][b].roomPattern = [];
            for(rs=0; (s=this.fetch[ys][b].roomSlot[rs])>=0 && rs<3; rs++) {
              this.fetch[ys][b].roomPattern[rs] = new Array(t,Math.pow(2,s%32));
            }
//            java.lang.System.out.println(this.fetch[ys][b].roomPattern.toString());
          }
          if (!this.fetch[ys][b].hourPattern) {
            this.fetch[ys][b].hourPattern = [];
            for(hs=0; (s=this.fetch[ys][b].hourSlot[hs])>=0 && hs<9; hs++) {
              this.fetch[ys][b].hourPattern[hs] = new Array(t,0,0,0);
              this.fetch[ys][b].hourPattern[hs][1+parseInt(s/32)] = Math.pow(2,s%32);
              q=((s%4)+1)%4;
              for(j=1; !(Math.pow(2,q)&this.fetch[ys][b].hourScope)&&j<4; q=(q+1)%4, j++) {
                this.fetch[ys][b].hourPattern[hs][1+parseInt((s+j)/32)] |= Math.pow(2,(s+j)%32);
              }
            }
//            java.lang.System.out.println(this.fetch[ys][b].hourPattern.toString());
          }
          if (!this.room.count[ys]) this.room.count[ys] = [];
          for(rs=0; (s=this.fetch[ys][b].roomSlot[rs])>=0 && rs<3; rs++) {
            if (!this.room.count[ys][s]) this.room.count[ys][s] = [];
            for(hs=0; hs<this.fetch[ys][b].hourPattern.length; hs++) {
              this.room.count[ys][s][this.room.count[ys][s].length] = this.fetch[ys][b].hourPattern[hs];
            }
          }
          if (!this.hour.count[ys]) this.hour.count[ys] = [];
          for(hs=0; (s=this.fetch[ys][b].hourSlot[hs])>=0 && hs<9; hs++) {
            if (!this.hour.count[ys][s]) this.hour.count[ys][s] = [];
            for(rs=0; rs<this.fetch[ys][b].roomPattern.length; rs++) {
              this.hour.count[ys][s][this.hour.count[ys][s].length] = this.fetch[ys][b].roomPattern[rs];
            }
            q=((s%4)+1)%4;
            for(j=1; !(Math.pow(2,q)&this.fetch[ys][b].hourScope); q=(q+1)%4, j++) {
              if (!this.hour.count[ys][s+j]) this.hour.count[ys][s+j] = [];
              for(rs=0; rs<this.fetch[ys][b].roomPattern.length; rs++) {
                this.hour.count[ys][s+j][this.hour.count[ys][s+j].length] = this.fetch[ys][b].roomPattern[rs];
              }
            }
          }
// for(s=0; s<this.room.count[ys].length; s++) {
//   if (this.room.count[ys][s]) {
//     java.lang.System.out.println("ROOM:YS"+ys+":"+"S"+s+":");
//     for(p=0; p<this.room.count[ys][s].length; p++) {
//       java.lang.System.out.println("  "+this.room.count[ys][s][p].toString());
//     }
//   }
// }
// for(s=0; s<this.hour.count[ys].length; s++) {
//   if (this.hour.count[ys][s]) {
//     java.lang.System.out.println("HOUR:YS"+ys+":"+"S"+s+":");
//     for(p=0; p<this.hour.count[ys][s].length; p++) {
//       java.lang.System.out.println("  "+this.hour.count[ys][s][p].toString());
//     }
//   }
// }
        }
      }
// should force through update to displayed value, may mean check below
// on undefined value not required?
      this.hour.value[ys] = [];
      this.room.value[ys] = [];
    }
  }


// TEMPORARILY COMMENTED OUT
//
//
// now process count lists above based on filter values (filter must
// flag changes required here ???) to produce grid values
// based on displayed in both directions
// can also be called here with no change in pattern (eg. for scroll)
//
// note: this doesnt respond to selected cells yet
// these just override the filter setting for hour/qtr or room to use
// the selected values as the filter instead - however note that these
// can then change on a per-row basis, and how changes are detected and
// triggered through magic? is not yet clear
//

// now recalc values as necessary

  y=Math.round(this.guide.getYfactor()*(this.match.length-this.outerheight));
  for (r=0; r<this.innerheight; r++, y++) {
    ys=this.match[y];
    for (p=0; p<this.pane.length; p++) {
      pane=this.pane[p];
// this probably conflicts with "uptpdate" checks
      if (!this[pane].value[ys]) this[pane].value[ys] = [];
      if (this[pane].selectc[r]) {
        pattern=this[pane].select[r];
        pattern[0]=this.slotpattern&0x7;
        ipattern=pattern;
        patternc=this[pane].selectc[r];
      }
      else {
        pattern=this[pane].peer.xpattern;
        ipattern=this[pane].peer.xpatterni;
        patternc=this[pane].peer.xpatternc;
      }
      x=Math.round(this[pane].guide.getXfactor() * (this[pane].match.length - this[pane].outerwidth));
      for (c=0; c<this[pane].innerwidth; c++, x++) {
        xs=this[pane].match[x];
        if (!this[pane].value[ys][xs])
          this[pane].value[ys][xs] = new GridValue();
// magic marker may need to be non-pane specific?
        if (this[pane].value[ys][xs].magic<this.magic) {
          s=0;
          sxs=xs;
          do {
            if (this[pane].count[ys][xs]) {
// java.lang.System.out.println("> P="+pattern.toString());
              for (v=0; v<this[pane].count[ys][xs].length; v++) {
                if (this[pane].count[ys][xs][v][0]&pattern[0]) {
                  for (xp=1; !(this[pane].count[ys][xs][v][xp]&pattern[xp])&&xp<pattern.length; xp++);
// java.lang.System.out.println("  X="+this[pane].count[ys][xs][v][xp]+"("+xp+")");
                  if (xp<pattern.length) s+=this[pane].peer.xpatternr;
                  if (p) {
                    for (xp=1; !(this[pane].count[ys][xs][v][xp]&ipattern[xp])&&xp<pattern.length; xp++);
                    if (xp<pattern.length) s+=this[pane].peer.xpatternr;
                  }
                }
              }
            }
            xs=(xs+1)%96;
          } while (!p&&!(Math.pow(2,xs&3)&this[pane].pattern[1]));
// account for res. and multiple passes above, this is hackish and not
// quite right anyway, done for ns as well further below
          if (!p) s /= 4;
          xs=sxs;
          if (this.slotpattern&0x8) {
            pattern[0] = (~pattern[0])&0x7;
            ns=0;
            sxs=xs;
            do {
              if (pattern[0] && this[pane].count[ys][xs]) {
                for (v=0; v<this[pane].count[ys][xs].length; v++) {
                  if (this[pane].count[ys][xs][v][0]&pattern[0]) {
                    for (xp=1; !(this[pane].count[ys][xs][v][xp]&pattern[xp])&&xp<pattern.length; xp++);
                    if (xp<pattern.length) ns+=this[pane].peer.xpatternr;
                  }
                }
              }
              xs=(xs+1)%96;
            } while (!p&&!(Math.pow(2,xs&3)&this[pane].pattern[1]));
            if (!p) ns /= 4;
            xs=sxs;
//     java.lang.System.out.println(">NS"+ns+":"+patternc);
            if (!ns) {
              this[pane].value[ys][xs].hidden = false;
              this[pane].value[ys][xs].weight = 3-parseInt((patternc-s)/patternc/(1/3));
//     java.lang.System.out.println("("+ys+","+xs+")>"+this[pane].value[ys][xs].weight);
            } else {
              this[pane].value[ys][xs].hidden = true;
            }
            pattern[0] = (~pattern[0])&0x7;
          }
          else if (!s) {
            this[pane].value[ys][xs].hidden = true;
          } else {
            this[pane].value[ys][xs].hidden = false;
            this[pane].value[ys][xs].weight = 3-parseInt((patternc-s)/patternc/(1/3));
          }
          this[pane].value[ys][xs].magic = this.magic;
        }

// java.lang.System.out.println(pane+"("+ys+","+xs+"):hidden="+this[pane].value[ys][xs].hidden+";"+"weight="+this[pane].value[ys][xs].weight);

      }
    }
  }



//
// final stage: update actual displayed cells to match current values
// as calculated above
//
// may always have to do both panes (dependent on what filters have changed)
// maybe split update into h-filter and v-filter change as the behaviour
// will be different, leave for now
//
// below doesnt handle color updates for selected cells
// or clearing of selected cells on scroll/filter update (actually if
// update is triggered scroll/filter or possibly new bookings appearing
// must have caused trigger), so old version just reset any selected
// cells - now selection of cells must trigger update themselves to
// rebuild display?

  y=Math.round(this.guide.getYfactor()*(this.match.length-this.outerheight));
  for (r=0; r<this.innerheight; r++, y++) {
    ys=this.match[y];
    for (p=(ip<0)?0:ip; (ip<0)?p<this.pane.length:p==ip; p++) {
      pane=this.pane[p];
      x=Math.round(this[pane].guide.getXfactor() * (this[pane].match.length - this[pane].outerwidth));
      for (c=0; c<this[pane].innerwidth; c++, x++) {
        xs=this[pane].match[x];
//java.lang.System.out.println("*** "+pane+":"+ys+":"+xs);
        if (this[pane].cell[r][c].index!=this[pane].value[ys][xs].hidden) {
          if (this[pane].value[ys][xs].hidden)
            SET_LYR_HIDDEN(this[pane].cell[r][c].divname);
          else
            SET_LYR_VISIBLE(this[pane].cell[r][c].divname);
          this[pane].cell[r][c].index = this[pane].value[ys][xs].hidden;
        }
        if (!this[pane].value[ys][xs].hidden) {
          if (this[pane].cell[r][c].select)
            SET_LYR_BGCOLOR(this[pane].cell[r][c].divname,'orange');
          else {
            if (this[pane].cell[r][c].state!=this[pane].value[ys][xs].weight) {
              if (this[pane].value[ys][xs].weight==0)
                SET_LYR_BGCOLOR(this[pane].cell[r][c].divname,'white');
              else if (this[pane].value[ys][xs].weight==1)
                SET_LYR_BGCOLOR(this[pane].cell[r][c].divname,'#AAAAAA');
              else if (this[pane].value[ys][xs].weight==2)
                SET_LYR_BGCOLOR(this[pane].cell[r][c].divname,'#707070');
              else SET_LYR_BGCOLOR(this[pane].cell[r][c].divname,'black');
              this[pane].cell[r][c].state = this[pane].value[ys][xs].weight;
            }
          }
        }
      }
    }
  }

// on scroll need to check for selected entries and deselect and recalc
// value

}

// called on vertical scroll event

function gridScroll(t) {
var y, r, ys, p, pane, c, i;
  t.leader();

// scroll update, checks for any displayed rows having selections on
// either pane and marks them cleared and reapplies filter rules
// part copied to pane scroll below
// regenerates all rows (inefficient) but row to regenerate has already
// moved perhaps?
// below works but is pretty inefficient (ie. redoes everything), would
// be faster to maintain a selection list per pane and only clear the
// entries on the list


// changing the filter is not clearing selections either, wait to do this
// till we have a selection list working would be better

// note - also needs to be done, display of selected cells always overrides
// the weight value

// technically only need to do this loop if we have at least one selection
// and skip it otherwise would be significantly more efficient

  y=Math.round(t.guide.getYfactor()*(t.match.length-t.outerheight));
  for (r=0; r<t.innerheight; r++, y++) {
    ys=t.match[y];
    for (p=0; p<t.pane.length; p++) {
      pane=t.pane[p];
      for (c=0; c<t[pane].innerwidth; c++) {
        if (t[pane].cell[r][c].select==1) {
          SET_LYR_BGCOLOR(t[pane].cell[r][c].divname,'white');
          t[pane].cell[r][c].select = 0;
          t[pane].cell[r][c].state = 0;
        }
      }
// affects peer pane not scrolled pane
//      t[pane].selectc[r]=0;
      t[pane].peer.selectc[r] = 0;
// affects peer pane not scrolled pane
//      for(i=0; i<t[pane].select[r].length; i++) {
//        t[pane].select[r][i]=0;
//      }
      for(i=0; i<t[pane].peer.select[r].length; i++) {
        t[pane].peer.select[r][i]=0;
      }
      t[pane].selectl[r] = [];
      t[pane].value[ys]=[];
    }
  }
// with selections on panes cleared action button must be disabled
  if (book.state) {
    book.state = 0;
    book.leave();
  }

  t.update(-1);
}

// called on horizontal scroll event

function gridPaneScroll(t) {
var y, r, ys, i, c;
  t.leader();

// scroll update, checks for any displayed rows having selections on
// the pane and marks them cleared and reapplies filter rules
// needs to be localised

  y=Math.round(t.grid.guide.getYfactor()*(t.grid.match.length-t.grid.outerheight));
  for (r=0; r<t.grid.innerheight; r++, y++) {
    ys=t.grid.match[y];
    for (c=0; c<t.innerwidth; c++) {
      if (t.cell[r][c].select==1) {
        SET_LYR_BGCOLOR(t.cell[r][c].divname,'white');
        t.cell[r][c].select = 0;
        t.cell[r][c].state = 0;
      }
    }
// affects peer pane not scrolled pane
//    t.selectc[r]=0;
    t.peer.selectc[r]=0;
// affects peer pane not scrolled pane
//    for(i=0; i<t.select[r].length; i++) {
//      t.select[r][i]=0;
//    }
    for(i=0; i<t.peer.select[r].length; i++) {
      t.peer.select[r][i]=0;
    }
    t.selectl[r] = [];
    t.value[ys]=[];
    t.peer.value[ys]=[];
  }
// with selections on a pane cleared action button must be disabled
  if (book.state) {
    book.state = 0;
    book.leave();
  }


// change to update both panes, as selection clearing can change both
// this is inefficient of course and we could probably be cleverer
//  t.update(0); // updates active grid, never addresses blanks
  t.grid.update(-1);
}

// called on grid update time/data event

function gridCGISelect(n) {
  select.now = n;
  select.call(this.fetchtime);
}

function gridSelect(n) {
var bookings, mf, me, u, data, o, i, j, p, ds, fd, r, tz;

// calculate base date number (ie. start of version, not today)
// ie. offset is from base date, but bookings will only be included
// from the current date - this is just to get indexing right
  bookings = new Result(select.answer);
  n = select.now;

  if (this.match.length>0) {
    mf=Math.round(this.guide.getYfactor()*(this.match.length-this.outerheight));
    me=mf+this.innerheight-1;
  } else {
    mf = -1;
  }
  for (u=0,i=-1,r=0; bookings&&bookings.next(); r++) {
    data = new GridData(bookings.current);

// we account for local timezone offset here!
// we actually need the timezone applying to the booked date
    fd = new Date();
    fd.setTime(data.dateTime*1000);
    tz=fd.getTimezoneOffset();
    o=parseInt(1+(data.dateTime*1000-tz*60*1000-baseDate.getTime())/86400000)-1;
    if (i!=o) {
      i=o;
      if (!u && mf>=0 && i>=this.match[mf] && i<=this.match[me]) {
        for (j=mf; j<=me; j++) {
          if (i==this.match[j]) {
            u=1;
            break;
          }
        }
      }
      for (p=0; p<this.pane.length; p++) {
        this[this.pane[p]].count[i] = [];
      }
    }
    if (data.replaces<0) {
      if (!this.fetch[i]) this.fetch[i] = [];
      this.fetch[i][this.fetch[i].length] = data;
    } else {
      for (j=0; j<this.fetch[i].length &&
        this.fetch[i][j].reference!=data.replaces; j++);
      this.fetch[i][j] = data;
    }
    this.fetchtime =
      Math.max(this.fetchtime,Math.max(data.openedAt,data.closedAt));
    this.fetchref = Math.max(this.fetchref,data.reference);
//     java.lang.System.out.println("<"+i+">  "+this.fetch[i].toString());
  }
// if first fetch was empty make sure we do real fetches from now on
  if (!this.fetchtime) this.fetchtime=1;

  ds=parseInt(1+(n.getTime()-baseDate.getTime())/86400000)-1;
  if (ds!=this.datastart) {
    this.datastart=ds;
    if (this.datastart>this.data.length) {
      // version expiry code
    }
    this.filter();
    this.update(-1);
  }
  else if (u) this.update(-1);
// only really needs to do this the first time though
  SET_LYR_HIDDEN('waitDiv');

// NOTE: Can count list be empty because of no bookings (in which case
// don't reprocess (need extra flag) or will it be contain multiple empty
// records for each slot, in which case no extra flag needed as even days
// with no bookings have some structure in count list
}

// these in turn call gridAdjust, gridPaneAdjust or gridPaneCellAdjust
// the pane xref may need to be held in feature (or at least the name)?
// feature calls this.grid.adjust(x,y) so 'this' below is 'grid' OR
// calls this.grid[this.grid.pane[p]].adjust(x,y) for pane
// custom update args would not be required - except for xpattern build?
// sub-feature adjust call parent feature adjust pattern (eg. hr qtrs)?
// -1 is grid update, else 0..N is respective pane index update
// this is feature arg instead of update function

function gridAdjust(ns,i) {
  if (ns!=this.pattern[i]) {
    this.pattern[i]=ns;
    this.filter();
    this.update(-1);
  }
}

function gridPaneAdjust(ns,i) {
  if (ns!=this.pattern[i]) {
    this.pattern[i]=ns;
    this.filter();
    this.grid.magic++;
// note the arg is no longer needed - only scroll events have separate
// pane updates, this could be changed or a special scroll update (as
// a sub-part of the main update) could be implemented just for that
    this.grid.update(-1);
  }
}

// hmm, where does the cross pattern for the slot get initialised?
// is this redundant (done in update)?

function gridSlotAdjust(ns) {
var p;
  if (ns != this.slotpattern) {
    this.slotpattern = ns;
    this.magic++;
    for (p=0; p<this.pane.length; p++) {
      this[this.pane[p]].xpattern[0] = this.slotpattern&0x7;
    }
    this.update(-1);
  }
}

function gridLaunch() {
var p;
  this.guide.activate();
  for (p=0; p<this.pane.length; p++) {
    this[this.pane[p]].launch();
  }
  // initialize mouse events
  document.onmousedown = ScrollBarMouse;
  document.onmousemove = ScrollBarMouse;
  document.onmouseup = ScrollBarMouse;
}

function gridPaneLaunch() {
  this.guide.activate();
  this.filter();
}

// Object: grid

function Grid(n,dn,t,o,w,h,lw,lh,d) {
  this.name = n; // name of grid
  this.divname = dn; // div name of grid
  this.text = t; //title of grid
  this.data = d; // array of raw pattern/header/value data (RECORDS)
  this.imgsrc = []; // image data array
  this.match = []; // array of matching data indexes

  this.datastart = -1; // first element of data to consider, changes each day
                     // when this exceeds data length (or -offset) then
                     // the version has expired, initially set on refresh

  this.fetchtime = 0; // fetch data >= this timestamp value
  this.fetchref = 0; // most recent fetched reference, used for dbl book check
  this.fetch = []; // array of fetched records per data index

  this.outerheight = o; // number of rows in grid window
  this.innerheight = o; // number of rows in grid window without blank rows
  this.cellwidth = w; // width in pixels of each column in grid window
  this.cellheight = h; // height in pixels of each row in grid window
  this.height = h * o + h - 1; // height of grid window in pixels
  this.width = -1; // width of grid window in pixels (derived from panes)
  this.unitheight = -1; // step size for window scrollbar in pixels
  this.handleheight = -1; // height of scrollbar handle in pixels
  this.leadwidth = lw; // lead column width in pixels
  this.leadheight = lh; // lead row height in pixels
  this.layout = gridLayout; // creates CSS for grid (recurses through panes)
  this.create = gridCreate; // creates DIV for grid (recurses through panes)
  this.append = gridAppend; // add a pane of columns to grid window
  this.leader = gridLeader; // update header row cells on scroll/reload
  this.scroll = gridScroll; // scroll event
  this.filter = gridFilter; // recreate match list (on changed criteria)
  this.update = gridUpdate; // reloads pane (event on load/scroll/criteria)
  this.select = gridSelect; // fetches grid data and updates as necessary
  this.cgiselect = gridCGISelect; // fetches grid data and updates vias CGIDBC
  this.adjust = gridAdjust; // handle filter changes, called from Feature
  this.remove = gridRemove; // remove a booking, called from detail display
  this.slotadjust = gridSlotAdjust; // handle cell filter changes, called from Feature
  this.launch = gridLaunch; // startup routine, calls pane launch routines
  this.pane = []; // array of grid window column panes
  this.lead = []; // 1D array of row header cells
  this.init = gridHeader; // initialise
  this.guide = null; // controller object
  this.pattern = []; // matching criteria for records
  this.magic = 1; // serial number for triggering display update
  this.slotpattern = 15; // cell value pattern (slot)
  this.locked = 0; // locked in booking detail mode (for remove/change)
}

// Object: pane of grid

function GridPane(n,dn,t,o,d) {
  this.name = n; // name of pane
  this.divname = dn; // div name of pane
  this.text = t; // title of pane
  this.data = d; // array of raw pattern/header data (COLUMNS)
  this.imgsrc = []; // image data array
  this.match = []; // array of matching data indexes
  this.outerwidth = o; // number of columns in grid pane
  this.innerwidth = o; // number of columns in grid pane without blank columns
  this.width = -1; // width of grid pane in pixels (derived on append)
  this.unitwidth = -1; // step size for window scrollbar in pixels
  this.handlewidth = -1; // width of scrollbar handle in pixels
  this.enter = gridEnter;
  this.leave = gridLeave;
  this.click = gridClick;
  this.layout = gridPaneLayout; // creates CSS for grid pane columns
  this.create = gridPaneCreate; // creates DIV for grid pane columns
  this.leader = gridPaneLeader; // update header column cells on scroll/reload
  this.scroll = gridPaneScroll; // scroll event
  this.filter = gridPaneFilter; // recreate match list (on changed criteria)
  this.adjust = gridPaneAdjust; // handle filter changes, called from Feature
  this.launch = gridPaneLaunch; // startup routines
  this.lead = []; // 1D array of column header cells
  this.cell = []; // 2D row/column array of grid cells
  this.cellwidth = -1; // width in pixels of each column (from parent)
  this.cellheight = -1; // height in pixels of each row (from parent)
  this.leadheight = -1; // height in pixels of lead row (from parent)
  this.guide = null; // controller object
  this.pattern = []; // matching criteria for pane columns
  this.patternsize = []; // size of each matching criteria for pane columns
  this.grid = null; // parent object pointer
  this.xpattern = []; // pattern of opposing pane
  this.xpatternc = null; // number of slots in pattern of opposing pane
  this.xpatternr = null; // resolution of slots in pattern of opposing pane
  this.xpatterni = []; // cross pattern inverted
  this.count = []; // array of all bookings per data index for this pane
  this.value = []; // array of grid values per data index for this pane
  this.select = []; // array of selected patterns per displayed data index
  this.selectc = []; // array of selected count per displayed data index
  this.selectl = []; // list of selected slots per displayed data index
  this.peer = null; // points to sibling pane
  this.imgdirpfx = null; // prefix to images sub-directory name

//  update = gridPaneUpdate() // reloads pane (event on load/scroll/criteria)
}

function GridCell(n,d,i) {
  this.name = n; // name of cell
  this.divname = d; // div name of cell
  this.imgname = i; // img name of cell
  this.image = 'images/spacer.gif';
  this.index = -1; // -1 hidden, 0 visible deslected, 1 visible selected
  this.state = 0; // 0 free, 1/2/3 other
  this.select = 0; // 0 deselected, 1 selected (replaces index)
}

function GridLeadCell(n,d,i) {
  this.name = n; // name of lead cell
  this.divname = d; // div name of lead cell
  this.imgname = i; // img name of cell
  this.index = -1; // index into data
}

function GridValue() {
  this.magic = 0; // serial number for update
  this.hidden = null; // whether visible or hidden
  this.weight = null; // usage display color
}

// OBJECT: Represents a room booking
// 'r' is a booking object instance

function GridData(a) {
  this.openedAt=a[0]-0;
  this.openedBy=a[1];
  this.reference=a[2]-0;
  this.replaces=a[3]-0;
  this.request=a[4]-0;
  this.reserve=a[5]-0;
  this.purpose=a[6];
  this.closedAt=a[7]-0;
  this.closedBy=a[8];
  this.closedAs=a[9]-0;
  this.reason=a[10];
  this.dateSlot=a[11]-0;
  this.hourScope=a[12]-0;
  this.hourSlot=[];
  this.hourSlot[0]=a[13]-0;
  this.hourSlot[1]=a[14]-0;
  this.hourSlot[2]=a[15]-0;
  this.hourSlot[3]=a[16]-0;
  this.hourSlot[4]=a[17]-0;
  this.hourSlot[5]=a[18]-0;
  this.hourSlot[6]=a[19]-0;
  this.hourSlot[7]=a[20]-0;
  this.hourSlot[8]=a[21]-0;
  this.roomSlot=[];
  this.roomSlot[0]=a[22]-0;
  this.roomSlot[1]=a[23]-0;
  this.roomSlot[2]=a[24]-0;
  this.dateTime=a[25]-0;
  this.hourPattern = null;
  this.roomPattern = null;
}

function resultNext() {
  this.row += 1;
  if (this.row < this.data.length) {
    this.current = this.data[this.row].split(',');
    return true;
  } else {
    this.current = null;
    return false;
  }
}

// Object: CGI ResultSet

function Result(r) {
  this.data = r ? r.split('|') : [] ; // array of records
  this.next = resultNext; // step to next record
  this.row = -1; // current record pointer
  this.current = null; // current record
}

// OBJECT: Represents an empty room booking

function GridBook(oby,rq,rs,p,cby,cas,r,hs) {
  this.openedAt=0;
  this.openedBy=oby;
  this.reference=0;
  this.replaces=-1;
  this.request=rq;
  this.reserve=rs;
  this.purpose=p;
  this.closedAt=0;
  this.closedBy=cby;
  this.closedAs=cas;
  this.reason=r;
  this.hourScope=hs;
  this.insert=gridInsert;
  this.booked=[];
  this.cgidata=null;
}

function gridInsert(ds,hs,rs) {
var h, r;
  with (this) {
    for (h=0; h<9; h++) {
      if (hs[h]==null) hs[h] = -1;
    }
    for (r=0; r<3; r++) {
      if (rs[r]==null) rs[r] = -1;
    }
    if (cgidata) cgidata += "|";
    else cgidata = "";
    cgidata+=openedAt+","+openedBy+","+reference+","+replaces+","+request+","+reserve+","+purpose+","+closedAt+","+closedBy+","+closedAs+","+reason+","+ds+","+hourScope+","+hs[0]+","+hs[1]+","+hs[2]+","+hs[3]+","+hs[4]+","+hs[5]+","+hs[6]+","+hs[7]+","+hs[8]+","+rs[0]+","+rs[1]+","+rs[2];
  }
  return(0);
}
